unit Main;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, Menus, ExtCtrls, ComCtrls, Grids, StdCtrls, Buttons,
    TLHELP32, PSAPI;

type
    //  vZXƂɌĂяoĂق֐^`
    TCancel = Boolean;
    TProcessFound = function(const ProcessEntry: TProcessEntry32;
                    const Err: Boolean; const ErrText: string): TCancel of object;

type
  TForm1 = class(TForm)
    MainMenu: TMainMenu;
    MenuFile: TMenuItem;
    MenuOption: TMenuItem;
    MenuView: TMenuItem;
    MenuHelp: TMenuItem;
    MenuAbout: TMenuItem;
    MenuExit: TMenuItem;
    MenuRefresh: TMenuItem;
    MenuFrequency: TMenuItem;
    MenuFrequencyHigh: TMenuItem;
    MenuFrequencyNormal: TMenuItem;
    MenuFrequencyLow: TMenuItem;
    MenuFrequencyPause: TMenuItem;
    MenuViewBreak: TMenuItem;
    MenuSelectCol: TMenuItem;
    MenuAlwaysShowTop: TMenuItem;
    Bevel1: TBevel;
    Panel1: TPanel;
    StatusBar: TStatusBar;
    PageControl1: TPageControl;
    TabApplication: TTabSheet;
    TabProcess: TTabSheet;
    TabPerformance: TTabSheet;
    Panel2: TPanel;
    BtnKillProcess: TBitBtn;
    Panel3: TPanel;
    GridProcess: TStringGrid;
    procedure FormCreate(Sender: TObject);
    procedure GridProcessDrawCell(Sender: TObject; ACol, ARow: Integer;
      Rect: TRect; State: TGridDrawState);
    procedure FormDestroy(Sender: TObject);
  private
    FStrBuf: TStringList; 
    procedure SetGridTitle();
    procedure UpdateProcessList();
    function ProcessFound(const ProcessEntry: TProcessEntry32;
                    const Err: Boolean; const ErrText: string): TCancel;
  public
    { Public 錾 }
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}

uses
    DateUtils;

//-----------------------------------------------------------------------------
//  vZXꗗ擾
//  http://nienie.com/~masapico/api_sample_ps05_c.html
//  http://nienie.com/~masapico/api_EnumProcesses.html
//  http://support.microsoft.com/default.aspx?scid=kb;ja;JP175030
//  http://www.borland.co.jp/qanda/delphi/d0003287.html
//  http://www2.big.or.jp/~osamu/Delphi/Tips/key.cgi?key=13
procedure SnapShotProcess(CallBack: TProcessFound);
var
    SnapShot: THandle;
    PE32: TProcessEntry32;
begin
    //  \̂̏
    FillChar(PE32, SizeOf(PE32), 0);
    PE32.dwSize := SizeOf(PE32);

    try
        // VXȅ̃XibvVbgƂ
        SnapShot := CreateToolhelp32Snapshot(TH32CS_SNAPPROCESS, 0);

        //  ꍇ
        if (SnapShot <> INVALID_HANDLE_VALUE) then
        begin
            try
                // ŏ̃vZX̌
                if Process32First(SnapShot, PE32) then
                begin
                    //  ʒm
                    repeat
                        if CallBack(PE32, False, '') then break;

                    // ̃vZX̌
                    until not Process32Next(SnapShot, PE32);
                end
                //  s
                else CallBack(PE32, False, '');
            finally
                CloseHandle(SnapShot);
            end;
        end
        //  sꍇ
        else
        begin
            CallBack(PE32, True, SysErrorMessage(GetLastError()));
        end;
    except
        on E: Exception do CallBack(PE32, True, E.Message);
    end;
end;

//-----------------------------------------------------------------------------
//  vZXnh̎擾
function GetProcessHandle(const ProcessID: Cardinal;
                var Handle: THandle; var Err: string): Boolean;
begin
    Handle := OpenProcess(PROCESS_QUERY_INFORMATION or PROCESS_VM_READ, False, ProcessID);
    Result := (Handle <> 0);
    if not Result then Err := SysErrorMessage(GetLastError());
end;

//-----------------------------------------------------------------------------
//  oCg𕶎\
function B2S(const ByteSize: Int64): string;
var
    Check: double;
begin
    Check := ByteSize;
    if (Check < 1024) then
    begin
        Result := FormatFloat('#,##0.00 B', Check);
    end
    else
    begin
        Check := Check / 1024;

        if (Check < 1024) then
        begin
            Result := FormatFloat('#,##0.00 KB', Check);
        end
        else
        begin
            Check := Check / 1024;
            Result := FormatFloat('#,##0.00 MB', Check);
        end;

        //Result := FormatFloat('#,##0.00 KB', Check);
    end;
end;

//-----------------------------------------------------------------------------
type
    //  { ULONGLONG = 64-bit unsigned integer.
    ULONGLONG = Int64;

    //  IO_COUNTERS
    _IO_COUNTERS = packed record
        ReadOperationCount  : ULONGLONG;    //  I/Oǂݎ
        WriteOperationCount : ULONGLONG;    //  I/O
        OtherOperationCount : ULONGLONG;    //  I/Ȏ
        ReadTransferCount   : ULONGLONG;    //  I/OǂݎoCg
        WriteTransferCount  : ULONGLONG;    //  I/O݃oCg
        OtherTransferCount  : ULONGLONG;    //  I/ȎoCg
    end;
    IO_COUNTERS = _IO_COUNTERS;
    PIO_COUNTERS = ^_IO_COUNTERS;
    TIoCounters = _IO_COUNTERS;
    PIoCounters = ^_IO_COUNTERS;

    //  GetProcessIoCounters({̓CgoCfBOׂ)
    function GetProcessIoCounters(
                hProcess: THandle;
                lpIoCounters: PIoCounters
                ): Boolean stdcall; external 'Kernel32.DLL' name 'GetProcessIoCounters';

    //  GetProcessHandleCount
    function GetProcessHandleCount(
                hProcess: THandle;
                pdwHandleCount: PDWORD
                ): Boolean stdcall; external 'Kernel32.DLL' name 'GetProcessHandleCount';

//-----------------------------------------------------------------------------
//  vZX擾
//  http://www.microsoft.com/japan/msdn/library/default.asp?url=/japan/msdn/library/ja/jpperfmo/html/_win32_GetProcessMemoryInfo.asp
//  http://www.ccn.aitai.ne.jp/~ccc/C++/Psapi.txt
//  http://nienie.com/~masapico/api_EmptyWorkingSet.html
function TForm1.ProcessFound(const ProcessEntry: TProcessEntry32;
                    const Err: Boolean; const ErrText: string): TCancel;

    function GetValue(const Valid: Boolean; const Value: string): string;
    begin
        if Valid then Result := Value else Result := '#VAL';
    end;

var
    Grid: TStringGrid;
    hProcess: THandle;
    Err2: string;

    pmc: TProcessMemoryCounters;
    pio: TIoCounters;
    phc: Cardinal;
//    ctime, etime, ktime, utime: TFileTime;
//    SystemTime: TSystemTime;
//    DateTime: TDateTime;

    ProcHandleOk: Boolean;
begin
    Grid := GridProcess;

    //  s𑝂₷
    Grid.RowCount := Grid.RowCount + 1;

    //  G[̏ꍇ͖
    if not Err then
    begin
        //  Kvȃf[^ǂǂƎoĂ

        ProcHandleOk := False;

        FillChar(pmc, SizeOf(pmc), 0);
        FillChar(pio, SizeOf(pio), 0);
        phc := 0;
//        DateTime := 0;

        //  vZXnh擾
        if GetProcessHandle(ProcessEntry.th32ProcessID, hProcess, Err2) then
        begin
            ProcHandleOk := True;

            //  
            pmc.cb := SizeOf(pmc);
            GetProcessMemoryInfo(hProcess, @pmc, SizeOf(pmc));

            //  I/O
            GetProcessIoCounters(hProcess, @pio);

            //  nh
            GetProcessHandleCount(hProcess, @phc);

            //  CPU?
//            GetProcessTimes(hProcess, ctime, etime, ktime, utime);
//            FileTimeToSystemTime(ktime, SystemTime);
//            DateTime := SystemTimeToDateTime(SystemTime);
        end;

        //  Zɒ@ޑOɃNA
        FStrBuf.Clear;

        //  C[W
        FStrBuf.Add(ProcessEntry.szExeFile);

        //  PID
        FStrBuf.Add(IntToStr(ProcessEntry.th32ProcessID));

        //  CPU
        FStrBuf.Add('-');

        //  CPU
//        FStrBuf.Add(GetValue(ProcHandleOk, FormatDateTime('hh:mm:ss', DateTime)));
        FStrBuf.Add('-');

        //  gp
        FStrBuf.Add(GetValue(ProcHandleOk, B2S(pmc.WorkingSetSize)));

        //  ő僁gp
        FStrBuf.Add(GetValue(ProcHandleOk, B2S(pmc.PeakWorkingSetSize)));

        //  f^
        FStrBuf.Add('-');

        //  y[WtHg
        FStrBuf.Add(GetValue(ProcHandleOk, B2S(pmc.PageFaultCount)));

        //  y[WtHgf^
        FStrBuf.Add('-');

        //  zTCY
        FStrBuf.Add(GetValue(ProcHandleOk, B2S(pmc.PagefileUsage)));

        //  y[Wv[
        FStrBuf.Add(GetValue(ProcHandleOk, B2S(pmc.QuotaPagedPoolUsage)));

        //  y[Wv[
        FStrBuf.Add(GetValue(ProcHandleOk, B2S(pmc.QuotaNonPagedPoolUsage)));

        //  {Dx
        FStrBuf.Add('-');

        //  nh
        FStrBuf.Add(IntToStr(phc));

        //  Xbh
        FStrBuf.Add('-');

        //  USERIuWFNg
        FStrBuf.Add('-');

        //  GDIIuWFNg
        FStrBuf.Add('-');

        //  I/Oǂݎ
        FStrBuf.Add(GetValue(ProcHandleOk, IntToStr(pio.ReadOperationCount)));

        //  I/O
        FStrBuf.Add(GetValue(ProcHandleOk, IntToStr(pio.WriteOperationCount)));

        //  I/Ȏ
        FStrBuf.Add(GetValue(ProcHandleOk, IntToStr(pio.OtherOperationCount)));

        //  I/OǂݎoCg
        FStrBuf.Add(GetValue(ProcHandleOk, IntToStr(pio.ReadTransferCount)));

        //  I/O݃oCg
        FStrBuf.Add(GetValue(ProcHandleOk, IntToStr(pio.WriteTransferCount)));

        //  I/ȎoCg
        FStrBuf.Add(GetValue(ProcHandleOk, IntToStr(pio.OtherTransferCount)));

        //  ]L
        Grid.Rows[Grid.RowCount - 1].CommaText := FStrBuf.CommaText;
    end;

    //  SvZX񋓂
    Result := False;
end;

//-----------------------------------------------------------------------------
const
    CELL_MARGIN = 2;

//-----------------------------------------------------------------------------
procedure TForm1.SetGridTitle();
var
    i: Integer;
    Grid: TStringGrid;
begin
    Grid := GridProcess;

    Grid.Rows[0].Clear;
    Grid.Rows[0].CommaText
        := 'C[W,PID,CPU,CPU,gp,ő僁gp,f^,'
         + 'y[WtHg,y[WtHgf^,zTCY,y[Wv[,'
         + 'y[Wv[,{Dx,nh,Xbh,USERIuWFNg,GDIIuWFNg,'
         + 'I/Oǂݎ,I/O,I/Ȏ,I/OǂݎoCg,I/O݃oCg,I/ȎoCg';

    for i := 0 to Grid.ColCount - 1 do
    begin
        Grid.ColWidths[i] := Grid.Canvas.TextWidth(Grid.Cells[i, 0]) + CELL_MARGIN * 2;
    end;
end;

//-----------------------------------------------------------------------------
procedure TForm1.UpdateProcessList();
begin
    GridProcess.RowCount := 1;
    SnapShotProcess(ProcessFound);
    GridProcess.FixedRows := 1;
end;

//-----------------------------------------------------------------------------
procedure TForm1.FormCreate(Sender: TObject);
begin
    FStrBuf := TStringList.Create;

    GridProcess.Canvas.Font.Assign(GridProcess.Font);
    SetGridTitle();

    UpdateProcessList();
end;

//-----------------------------------------------------------------------------
procedure TForm1.FormDestroy(Sender: TObject);
begin
    FreeAndNil(FStrBuf);
end;

//-----------------------------------------------------------------------------
procedure TForm1.GridProcessDrawCell(Sender: TObject; ACol, ARow: Integer;
  Rect: TRect; State: TGridDrawState);
var
    Grid: TStringGrid;
    Item: string;
    DrawFormat: Cardinal;
    DrawParams: TDrawTextParams;
    R: TRect;
begin
    Grid := TStringGrid(Sender);

    //  wihԂ
    Grid.Canvas.FillRect(Rect);

    //  o
    Item := Grid.Cells[ACol, ARow];

    //  `ݒ
    DrawFormat := DT_SINGLELINE or DT_VCENTER or DT_WORD_ELLIPSIS;

    //  ^Cgsǂ
    if (ACol * ARow = 0) then
    begin
        DrawFormat := DrawFormat or DT_LEFT;
    end
    else
    begin
        DrawFormat := DrawFormat or DT_RIGHT;
    end;

    //  gݒ
    FillChar(DrawParams, SizeOf(DrawParams), 0);
    DrawParams.cbSize := SizeOf(DrawParams);
    DrawParams.iLeftMargin := CELL_MARGIN;
    DrawParams.iRightMargin := CELL_MARGIN;

    //  `
    R := Rect;
    DrawTextEx(Grid.Canvas.Handle, PChar(Item), -1, R, DrawFormat, @DrawParams);
end;

end.
